require "help"
require "metaRect"
require "metaStar" 
require "metaBlock"

pinko = false
gloNormBlock = 1
gloHeartBlock = 2
Alpha = 255
AlphaSwitch = false
globalScale = 1
globalScaleSwitch = false 

pScoreBar = imgLoad("scoreBar")
pPlate = imgLoad("plate")
pBaseBlock = imgLoad("baseBlock")
pInStar = imgLoad("inStar")
pInHeart = imgLoad("inHeart")
pBlock = imgLoad("block")
pBlockTrail = imgLoad("box")
pBoyLeftGlow = imgLoad("boyLeftGlow")
pBoyRightGlow = imgLoad("boyRightGlow")
pBoyUpGlow = imgLoad("boyUpGlow")
pBoyDownGlow = imgLoad("boyDownGlow")



lGame = {
	state = "pause",
	isDown = false,
	pback = pload("img/back.png"),
	--plife = pload("img/life.png"),
	score = 0,
	chain = 0,
	time = 120,
	plus = 5,
	barhs = 400,
	bs = 500
}
lLevel = {scorePlus = 5, blockSpeed = 50, blockSpawn = 80}
lKey = {
	w = false,
	s = false,
	a = false,
	d = false,
	up = false,
	down = false,
	left = false,
	right = false
}

lBarLeft = {
	name = "lBarLeft",
	life = 3,
	pLife = imgLoad("lifeLeft"),
	isd = false,
	p = pload("img/barLeft.png"),
	phit = pload("img/barLeftHit.png"),
	thit = 0,
	psq = metaRect.make(0, 0, 40, 600),
	sq = metaRect.make(0, 0, 32, 600),
}
lBarRight = {
	life = 3,
	pLife = imgLoad("lifeRight"),
	isd = false,
	p = pload("img/barRight.png"),
	phit = pload("img/barRightHit.png"),
	thit = 0,
	psq = metaRect.make(800 - 40, 0, 40, 600),
	sq = metaRect.make(800 - 32, 0, 32, 600)
}
lBarUp = {
	life = 3,
	pLife = imgLoad("lifeUp"),
	isd = false,
	p = pload("img/barUp.png"),
	phit = pload("img/barUpHit.png"),
	thit = 0,
	psq = metaRect.make(0, 0, 800, 40),
	sq = metaRect.make(0, 0, 800, 32)
}
lBarDown = {
	life = 3,
	pLife = imgLoad("lifeDown"),
	isd = false,
	p = pload("img/barDown.png"),
	phit = pload("img/barDownHit.png"),
	thit = 0,
	psq = metaRect.make(0, 600 - 40, 800, 40),
	sq = metaRect.make(0, 600 - 32, 800, 32)
}

lBoyLeft = {
	name = "lBoyLeft",
	p = pload("img/boyLeft.png"),
	phit = pload("img/boyLeftHit.png"),
	poke = 0,
	ish = false,
	psq = metaRect.make(40, 264, 40, 64)
}
lBoyRight = {
	p = pload("img/boyRight.png"),
	phit = pload("img/boyRightHit.png"),
	poke = 0,
	psq = metaRect.make(800 - 80, 264, 40, 64)
}
lBoyUp = {
	p = pload("img/boyUp.png"),
	phit = pload("img/boyUpHit.png"),
	poke = 0,
	psq = metaRect.make(400 - 32, 40, 64, 40)
}
lBoyDown = {
	p = pload("img/boyDown.png"),
	phit = pload("img/boyDownHit.png"),
	poke = 0,
	psq = metaRect.make(400 - 32, 600 - 80, 64, 40)
}

star = metaStar:make(400, 300, true, true, 75)

function lKey:run()
	self.up = false
	self.down = false
	self.left = false
	self.right = false
	self.w = false
	self.s = false
	self.a = false
	self.d = false

	if(love.keyboard.isDown("up")) then self.up = true end
	if(love.keyboard.isDown("down")) then self.down = true end
	if(love.keyboard.isDown("left")) then self.left = true end
	if(love.keyboard.isDown("right")) then self.right = true end
	if(love.keyboard.isDown("w")) then self.w = true end
	if(love.keyboard.isDown("s")) then self.s = true end
	if(love.keyboard.isDown("a")) then self.a = true end
	if(love.keyboard.isDown("d")) then self.d = true end
end

function workLife(vscale, vi)
	return((vscale / 2) - (18 * vi))
end

function workSide(vRect)
	local xSide
	local ySide
	local modX = math.abs(vRect.x % 100)
	local modY = math.abs(vRect.y % 100)
	if vRect.x + (vRect.width / 2) < 400 then
		xSide = Left
	else
		xSide = Right
	end
	if vRect.y + (vRect.height / 2) < 300 then
		ySide = Up
	else
		ySide = Down
	end
	if modX > modY then
		return xSide
	else
		return ySide
	end
end

function limitLife()
	if(lBarLeft.life > 3) then lBarLeft.life = 3 end
	if(lBarRight.life > 3) then lBarRight.life = 3 end
	if(lBarUp.life > 3) then lBarUp.life = 3 end
	if(lBarDown.life > 3) then lBarDown.life = 3 end
end

function drawLife()
	for i = 1, lBarLeft.life do
		love.graphics.draw(lBarLeft.pLife, 12, workLife(600, i), 0, globalScale, globalScale, 8, 8)
	end
	for i = 1, lBarRight.life do
		love.graphics.draw(lBarRight.pLife, 800 - 12, workLife(600, i), 0, globalScale, globalScale, 8, 8)
	end
	for i = 1, lBarUp.life do
		love.graphics.draw(lBarUp.pLife, workLife(800, i), 12, 0, globalScale, globalScale, 8, 8)
	end
	for i = 1, lBarDown.life do
		love.graphics.draw(lBarDown.pLife, 22 + workLife(800, i), 600 - 12, 0, globalScale, globalScale, 8, 8)
	end
end

function runBars(d)
	if(lBarLeft.thit >= 0) then
		lBarLeft.thit = lBarLeft.thit - (lGame.barhs * d)
	end
	if(lBarRight.thit >= 0) then
		lBarRight.thit = lBarRight.thit - (lGame.barhs * d)
	end
	if(lBarUp.thit >= 0) then
		lBarUp.thit = lBarUp.thit - (lGame.barhs * d)
	end
	if(lBarDown.thit >= 0) then
		lBarDown.thit = lBarDown.thit - (lGame.barhs * d)
	end
	if(lBarLeft.life <= 0) then lBarLeft.isd = true end
	if(lBarRight.life <= 0) then lBarRight.isd = true end
	if(lBarUp.life <= 0) then lBarUp.isd = true end
	if(lBarDown.life <= 0) then lBarDown.isd = true end
end

function drawBars()
	if(lBarLeft.isd == false) then drawl(lBarLeft) end
	if(lBarRight.isd == false) then drawl(lBarRight) end
	if(lBarUp.isd == false) then drawl(lBarUp) end
	if(lBarDown.isd == false) then drawl(lBarDown) end
	
	if(lBarLeft.thit > 0) then
		love.graphics.setColor(255, 255, 255, lBarLeft.thit)
		love.graphics.draw(lBarLeft.phit, 0, 0)
	end
	if(lBarRight.thit > 0) then
		love.graphics.setColor(255, 255, 255, lBarRight.thit)
		love.graphics.draw(lBarRight.phit, 800 - 40, 0)
	end
	if(lBarUp.thit > 0) then
		love.graphics.setColor(255, 255, 255, lBarUp.thit)
		love.graphics.draw(lBarUp.phit, 0, 0)
	end
	if(lBarDown.thit > 0) then
		love.graphics.setColor(255, 255, 255, lBarDown.thit)
		love.graphics.draw(lBarDown.phit, 0, 600 - 40)
	end
	love.graphics.setColor(255, 255, 255, 255)
end

function runGlobalAlpha(dt)
	if(AlphaSwitch == false) then
		Alpha = Alpha + (200 * dt)
		if(Alpha >= 240) then AlphaSwitch = true end
	else
		Alpha = Alpha - (200 * dt)
		if(Alpha <= 10) then AlphaSwitch = false end
	end
	
	if(globalScaleSwitch == false) then
		globalScale = globalScale - (1 * dt)
		if(globalScale <= 0.5) then globalScaleSwitch = true end
	else
		globalScale = globalScale + (1 * dt)
		if(globalScale >= 1.0) then globalScaleSwitch = false end
	end
end

function drawBarTeeth()
	love.graphics.setColor(255, 255, 255, Alpha)
	love.graphics.draw(lBarLeft.phit, 0, 0)
	love.graphics.draw(lBarRight.phit, 800 - 40, 0)
	love.graphics.draw(lBarUp.phit, 0, 0)
	love.graphics.draw(lBarDown.phit, 0, 600 - 40)
	love.graphics.setColor(255, 255, 255, 255)
end

function drawScore()
	textScale = globalScale
	if(textScale < 0.8) then textScale = 0.8 end
		theColor:set()
	love.graphics.print("SCORE." .. lGame.score, 40, 16, 0, 1, 1)
	redColor:reset()
end

function doBoys(d)
	if(love.keyboard.isDown("left")) then
		lBoyUp.psq:moveX(-lGame.bs, d)
		lBoyDown.psq:moveX(-lGame.bs, d)
		
	elseif(love.keyboard.isDown("right")) then
		lBoyUp.psq:moveX(lGame.bs, d)
		lBoyDown.psq:moveX(lGame.bs, d)
	end
	if(love.keyboard.isDown("up")) then
		lBoyLeft.psq:moveY(-lGame.bs, d)
		lBoyRight.psq:moveY(-lGame.bs, d)
	elseif(love.keyboard.isDown("down")) then
		lBoyLeft.psq:moveY(lGame.bs, d)
		lBoyRight.psq:moveY(lGame.bs, d)
	end
	if(lBoyUp.psq.x < 79) then
		lBoyUp.psq.x = 79
		lBoyDown.psq.x = 79
	elseif(lBoyUp.psq.x > 800 - 64 - 79) then
		lBoyUp.psq.x = 800 - 64 - 79
		lBoyDown.psq.x = 800 - 64 - 79
	end
	if(lBoyLeft.psq.y < 79) then
		lBoyLeft.psq.y = 79
		lBoyRight.psq.y = 79
	elseif(lBoyLeft.psq.y > 600 - 64 - 79) then
		lBoyLeft.psq.y = 600 - 64 - 79
		lBoyRight.psq.y = 600 - 64 - 79
	end
end

function drawBoys()
	imgDraw(lBoyLeft)
	imgDraw(lBoyRight)
	imgDraw(lBoyUp)
	imgDraw(lBoyDown)
end

function runPoke(d)
	if(lBoyLeft.poke >= 0) then
		lBoyLeft.poke = lBoyLeft.poke - (300 * d)
	end
	if(lBoyRight.poke >= 0) then
		lBoyRight.poke = lBoyRight.poke - (300 * d)
	end
	if(lBoyUp.poke >= 0) then
		lBoyUp.poke = lBoyUp.poke - (300 * d)
	end
	if(lBoyDown.poke >= 0) then
		lBoyDown.poke = lBoyDown.poke - (300 * d)
	end
end

function drawPoke()
	if(lBoyLeft.poke >= 0) then
		love.graphics.setColor(255, 255, 255, lBoyLeft.poke)
		love.graphics.draw(pBoyLeftGlow, lBoyLeft.psq:flatx() + 40, lBoyLeft.psq:flaty())
		love.graphics.setColor(255, 255, 255, 255)
	end
	if(lBoyRight.poke >= 0) then
		love.graphics.setColor(255, 255, 255, lBoyRight.poke)
		love.graphics.draw(pBoyRightGlow, lBoyRight.psq:flatx() - 32, lBoyRight.psq:flaty())
		love.graphics.setColor(255, 255, 255, 255)
	end
	if(lBoyUp.poke >= 0) then
		love.graphics.setColor(255, 255, 255, lBoyUp.poke)
		love.graphics.draw(pBoyUpGlow, lBoyUp.psq:flatx(), lBoyUp.psq:flaty() + 40)
		love.graphics.setColor(255, 255, 255, 255)
	end
	if(lBoyDown.poke >= 0) then
		love.graphics.setColor(255, 255, 255, lBoyDown.poke)
		love.graphics.draw(pBoyDownGlow, lBoyDown.psq:flatx(), lBoyDown.psq:flaty() - 32)
		love.graphics.setColor(255, 255, 255, 255)
	end
end

function doStarBar()
	if(star:hitBar(lBarLeft, glol) == true and lBarLeft.life > 0) then
		lBarLeft.life = lBarLeft.life - 1
		lBarLeft.thit = 255
	end
	if(star:hitBar(lBarRight, glor) == true and lBarRight.life > 0) then
		lBarRight.life = lBarRight.life - 1
		lBarRight.thit = 255
	end
	if(star:hitBar(lBarUp, glou) == true and lBarUp.life > 0) then
		lBarUp.life = lBarUp.life - 1
		lBarUp.thit = 255
	end
	if(star:hitBar(lBarDown, glod) == true and lBarDown.life > 0) then
		lBarDown.life = lBarDown.life - 1
		lBarDown.thit = 255
	end
end

function doStarBoy()
	star:hitBoy(lBoyLeft.psq, glol)
	star:hitBoy(lBoyRight.psq, glor)
	star:hitBoy(lBoyUp.psq, glou)
	star:hitBoy(lBoyDown.psq, glod)
	
	if(star:pokeBoy(star.offRect, lBoyLeft, glol) == true) then
		lBoyLeft.poke = 255
	end
	if(star:pokeBoy(star.offRect, lBoyRight, glor) == true) then
		lBoyRight.poke = 255
	end
	if(star:pokeBoy(star.offRect, lBoyUp, glou) == true) then
		lBoyUp.poke = 255
	end
	if(star:pokeBoy(star.offRect, lBoyDown, glod) == true) then
		lBoyDown.poke = 255
	end
end

function love.load()
	love.mouse.setVisible(false)
	love.graphics.setCaption("~Push.ver.0.0.2~")
	font = love.graphics.newFont("img/font.ttf", 12)
	love.graphics.setFont(font)
	theColor = metaColor.make(209, 187, 59, 255)
	redColor = metaColor.make(204, 98, 59, 255)
end

function love.update(dt)
	if(lGame.state == "play") then
	if(love.keyboard.isDown(" ")) then
		if(lGame.isDown == false) then
			lGame.state = "pause"
			lGame.isDown = true
		end
	else
			lGame.isDown = false
	end
	lKey:run()
	lGame.time = lGame.time - (1 * dt)
	metaBlock:gen(lLevel, dt)
	blockAnimate(dt)
	runGlobalAlpha(dt)
	doBoys(dt)
	runPoke(dt)
	runBars(dt)
	for i, v in ipairs(lBlock) do
		if(v.noUse == true) then
			table.remove(lBlock, i)
		else
			v:run(dt)
		end
	end
	star:run(lKey, dt)
	doStarBar()
	doStarBoy()
	limitLife()
	elseif(lGame.state == "pause") then
		if(love.keyboard.isDown(" ")) then
	 		if(lGame.isDown == false) then
				lGame.state = "play"
				lGame.isDown = true	
			end
			else
			lGame.isDown = false
		end
	end
end

function love.draw()
	love.graphics.draw(lGame.pback, 0, 0)
	for i, v in ipairs(lBlock) do
		v:draw()
	end
	drawBars()
	drawLife()
	drawBoys()
	drawPoke()
	star:draw()
	drawScore()
	if(lGame.state == "pause") then
		love.graphics.setColor(0, 0, 0, 200)
		love.graphics.rectangle("fill", 0, 0, 800, 600)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(pPlate, 800 - 216, 600 - 150)
		love.graphics.setColor(209, 183, 73, 255)
		love.graphics.setColor(255, 255, 255, 255)
	end
	
end