pGlow = imgLoad("blockGlow")
pDeath = love.graphics.newImage("img/deathBlock.png")
pSkull = love.graphics.newImage("img/skull.png")
pDeathAni = love.graphics.newImage("img/deathAni.png")
pPokeLeft = love.graphics.newImage("img/pokeBlockLeft.png")
pPokeRight = love.graphics.newImage("img/pokeBlockRight.png")
pPokeUp = love.graphics.newImage("img/pokeBlockUp.png")
pPokeDown = love.graphics.newImage("img/pokeBlockDown.png")
BlockRotate = 0
BlockScale = 1
BlockSwitchScale = false

lBlock = {}

function blockAnimate(dt)
	BlockRotate = BlockRotate + (3 * dt)
	
	if(BlockScale > 0.5 and BlockSwitchScale == false) then
		BlockScale = BlockScale - (1 * dt) 
		if(BlockScale <= 0.5) then
			BlockSwitchScale = true
		end
	elseif(BlockSwitchScale == true) then
		BlockScale = BlockScale + (1 * dt)
		if(BlockScale >= 1.0) then
			BlockSwitchScale = false
		end
	end
end

metaBlock = {}
genSpeed = 100
function metaBlock:gen(vLevel, dt)
	genSpeed = genSpeed + (vLevel.blockSpawn * dt)
	da = true
	db = true
	x = 0
	y = 0
	type = 0
	if(genSpeed > 100) then
		genSpeed = 0
		
		local rda = math.random(0, 1)
		local rdb = math.random(0, 1)
		
		rType = math.random(0, 50)
		if rType > 30 then type = 3 end
		
		if rda == 1 then
			da = true
		else
			da = false
		end
		if rdb == 1 then
			db = true
		else
			db = false
		end
		
		if(da == true and db == true) then
			x = math.random(4, 20)
			y = 600 + 128
			x = x * 32
		elseif(da == true and db == false) then
			x = math.random(4, 20)
			y = -128
			x = x * 32
		elseif(da == false and db == true) then
			y = math.random(4, 16)
			x =  800 + 128
			y = y * 32
		elseif(da == false and db == false) then
			y = math.random(4, 16)
			y = y * 32
			x = -128
		end
		metaBlock:make(type, x, y, da, db, vLevel.blockSpeed)
		end
end

function metaBlock:make(vt, vx, vy, vda, vdb, vs)
	local o = {}
	setmetatable(o, metaBlock)
	self.__index = self
	o.lFade = {}
	o.type = vt
	o.rect = metaRect.make(vx, vy, 32, 32)
	o.da = vda
	o.db = vdb
	o.s = vs
	o.isd = false
	o.noUse = false
	o.dclo = 100
	o.sc = 1
	o.trail = 0
	o.pokeLeft = 0
	o.pokeRight = 0
	o.pokeUp = 0
	o.pokeDown = 0
	table.insert(lBlock, o)
	return o
end

function metaBlock:run(dt)
	self.trail = self.trail + ((self.s * 5) * dt)
	if(self.noUse) then
	
	end
	if(self.trail >= (self.s / 2)) then
		n = {x = self.rect.x, y = self.rect.y, opa = 10}
		table.insert(self.lFade, n)
		self.trail = 0
	end
	
	if(self.da == true) then
		if(self.db == true) then
			self.rect.y = self.rect.y - (self.s * dt)
			if(self.rect.y < -128) then self.noUse = true end
		else
			self.rect.y = self.rect.y + (self.s * dt)
			if(self.rect.y > 600 + 128) then self.noUse = true end
		end
	else
		if(self.db == true) then
			self.rect.x = self.rect.x - (self.s * dt)
			if(self.rect.x < -128) then self.noUse = true end
		else
			self.rect.x = self.rect.x + (self.s * dt)
			if(self.rect.x > 800 + 128) then self.noUse = true end
		end
	end
	
	self:runFade(dt)
	self:runPoke(dt)
	
	if self.isd and self.type == 1 then
			self.sc = self.sc - (6 * dt)
			if self.sc <= 0 then
				self.noUse = true
			end
	end
end

function metaBlock:runPoke(dt)
	if self.pokeLeft > 0 then self.pokeLeft = self.pokeLeft - (300 * dt) end
	if self.pokeRight > 0 then self.pokeRight = self.pokeRight - (300 * dt) end
	if self.pokeUp > 0 then self.pokeUp = self.pokeUp - (300 * dt) end
	if self.pokeDown > 0 then self.pokeDown = self.pokeDown - (300 * dt) end
	
	if self.pokeLeft < 0 then self.pokeLeft = 0 end
	if self.pokeRight < 0 then self.pokeRight = 0 end
	if self.pokeUp < 0 then self.pokeUp = 0 end
	if self.pokeDown < 0 then self.pokeDown = 0 end
end

function metaBlock:runFade(dt)
	for i, v in ipairs(self.lFade) do
		v.opa = v.opa - (self.s / 4 * dt)
		if(v.opa <= 0) then
			table.remove(self.lFade, i)
		end
	end
end

function metaBlock:drawFade()
	theColor:setWithAlpha(50)
	if self.da then
		if self.db then
			love.graphics.line(self.rect.x + self.rect.width / 2, self.rect.y + self.rect.height / 2, self.rect.x + self.rect.width / 2, self.rect.y + self.rect.height / 2 + 60)
		else
			love.graphics.line(self.rect.x + self.rect.width / 2, self.rect.y + self.rect.height / 2, self.rect.x + self.rect.width / 2, self.rect.y + self.rect.height / 2 - 60)
		end
	else
		if self.db then
		else
		end
	end
	theColor:reset()
	--[[
	for i, v in ipairs(self.lFade) do
	 	theColor:setAlpha(v.opa)
		love.graphics.draw(pBlockTrail, v.x, v.y, 0, 1, 1, 8, 8)
		theColor:reset()
	end
	]]--
end

function metaBlock:draw()
	if self.pokeLeft > 0 then
		theColor:setAlpha(self.pokeLeft)
		love.graphics.draw(pPokeLeft, self.rect.x - 20, self.rect.y - 4)
	end
	if self.pokeRight > 0 then
		theColor:setAlpha(self.pokeRight)
		love.graphics.draw(pPokeRight, self.rect.x + self.rect.width - 4, self.rect.y - 4)
	end
	if self.pokeUp > 0 then
		theColor:setAlpha(self.pokeUp)
		love.graphics.draw(pPokeUp, self.rect.x - 4, self.rect.y - 20)
	end
	if self.pokeDown > 0 then
		theColor:setAlpha(self.pokeDown)
		love.graphics.draw(pPokeDown, self.rect.x - 4, self.rect.y + self.rect.height - 4)
	end
	theColor:reset()
	--self:drawFade()
	if(self.type == 0) then
		love.graphics.draw(pBaseBlock, self.rect.x, self.rect.y, 0, 1, 1, 8, 8)
	elseif(self.type == 1) then
		if(not self.isd) then
			self:drawFade()
			love.graphics.draw(pBlock, self.rect.x, self.rect.y, 0, 1, 1, 8, 8)
			theColor:reset()
			love.graphics.draw(pInStar, self.rect.x + 12, self.rect.y + 12, BlockRotate, 1, 1, 16, 16)
			love.graphics.draw(pInStar, self.rect.x + 12, self.rect.y + 12, BlockRotate, 1, 1, 16, 16)
		else
			self:ddie()
		end
	elseif(self.type == 2) then
		love.graphics.draw(pBlock, self.rect.x, self.rect.y, 0, 1, 1, 8, 8)
		love.graphics.draw(pInHeart, self.rect.x + 12, self.rect.y + 12, 0, BlockScale, BlockScale, 16, 16)
	elseif(self.type == 3) then
		love.graphics.draw(pDeath, self.rect.x, self.rect.y, 0, 1, 1, 20, 20)
		theColor:setAlpha(Alpha)
		love.graphics.draw(pSkull, self.rect.x, self.rect.y, 0, 1, 1, 20, 20)
		theColor:reset()
	end
end

function metaBlock:ddie()
	if self.type == 1  then
		love.graphics.draw(pBlock, self.rect.x + 12, self.rect.y + 12, 0, self.sc, self.sc, 20, 20)
	elseif self.type == gloHeartBlock then
		love.graphics.draw(pBlock, self.rect.x + 12, self.rect.y + 12, 0, self.sc, self.sc, 20, 20)
	end
end
