
metaRect = {}
metaRect.__index = metaRect
function metaRect.make(vx, vy, vwidth, vheight)
	local item = {}
	setmetatable(item, metaRect)
		item.x = vx
		item.y = vy
		item.width = vwidth
		item.height = vheight
	return item
end

function metaRect:doHit(vRect)
	if(self.x > (vRect.x + vRect.width) or (self.x + self.width) < vRect.x) then
		return false
	end
	if(self.y > (vRect.y + vRect.height) or (self.y + self.height) < vRect.y) then
		return false
	end
	return true
end

function metaRect:sideHit(vRect)
		local xOff = math.abs(vRect.x + vRect.width / 2 - self.x)
		local yOff = math.abs(vRect.y + vRect.height / 2 - self.y)
		if(xOff > yOff) then
			if self.x + self.width / 2 <= vRect.x + vRect.width / 2 then return Left end
			return Right
		else
			if self.y + self.height / 2 < vRect.y + vRect.height / 2 then return Up end
			return Down
		end 
	return nil
end

function metaRect:hardHit(vrect)
	if self:doHit(vrect) then
		local grabSide = self:sideHit(vrect)
		if grabSide == Left then
			self.x = vrect.x + self.width
			return Left
		end
		if grabSide == Right then
			self.x = vrect.x + vrect.width
			return Right
		end
		if grabSide == Up then
			self.y = vrect.y - self.height
			return Up
		 end
		if grabSide == Down then
			self.y = vrect.y + vrect.height
			return Down
		end
	end
	return nil
end

function metaRect:moveX(speed, delta)
	self.x = self.x + speed * delta
end

function metaRect:moveY(speed, delta)
	self.y = self.y + speed * delta
end

function metaRect:doFloor()
	self.x = math.floor(self.x)
	self.y = math.floor(self.y)
end

function metaRect:flatx()
	return math.floor(self.x)
end

function metaRect:flaty()
	return math.floor(self.y)
end

function metaRect:doDraw()
	love.graphics.rectangle("line", self:flatx(), self:flaty(), self.width, self.height)
end
